Index: XIOS3/trunk/src/manager/servers_ressource.cpp
===================================================================
--- XIOS3/trunk/src/manager/servers_ressource.cpp	(revision 2546)
+++ XIOS3/trunk/src/manager/servers_ressource.cpp	(revision 2547)
@@ -9,4 +9,5 @@
 #include <vector>
 #include <string>
+#include "thread_manager.hpp"
 
 
@@ -43,4 +44,5 @@
     eventScheduler_ = make_shared<CEventScheduler>(freeRessourcesComm_) ;
     freeRessourceEventScheduler_ = eventScheduler_ ;
+    if (CThreadManager::isUsingThreads()) CThreadManager::spawnThread(&CServersRessource::threadEventLoop, this) ;
   }
 
@@ -131,5 +133,6 @@
     if (poolRessource_!=nullptr) 
     {
-      if (poolRessource_->eventLoop(serviceOnly))
+      poolRessource_->eventLoop(serviceOnly) ;
+      if (poolRessource_->isFinished())
       {
         delete poolRessource_ ;
@@ -139,7 +142,45 @@
     }
     CTimer::get("CServersRessource::eventLoop").suspend();
-    if (poolRessource_==nullptr && finalizeSignal_) return true ;
-    else return false ;
-  }
+    if (poolRessource_==nullptr && finalizeSignal_) finished_=true ;
+    return finished_ ;
+  }
+
+  void CServersRessource::threadEventLoop(void)
+  {
+    CTimer::get("CServersRessource::eventLoop").resume();
+    info(100)<<"Launch Thread for  CServersRessource::threadEventLoop"<<endl ;
+    CThreadManager::threadInitialize() ; 
+
+    do
+    {
+      double time=MPI_Wtime() ;
+      int flag ;
+      MPI_Iprobe(MPI_ANY_SOURCE, MPI_ANY_TAG, MPI_COMM_WORLD, &flag, MPI_STATUS_IGNORE);
+
+      if (time-lastEventLoop_ > eventLoopLatency_) 
+      {
+        checkNotifications() ;
+        lastEventLoop_=time ;
+      }
+
+      if (poolRessource_!=nullptr) 
+      {
+        if (poolRessource_->isFinished())
+        {
+          delete poolRessource_ ;
+          poolRessource_=nullptr ;
+          // don't forget to free pool ressource later
+        } 
+      }
+      CTimer::get("CServersRessource::eventLoop").suspend();
+      if (poolRessource_==nullptr && finalizeSignal_) finished_=true ;
+      if (!finished_) CThreadManager::yield() ;
+    
+    } while (!finished_) ;
+
+    CThreadManager::threadFinalize() ;
+    info(100)<<"Close thread for CServersRessource::threadEventLoop"<<endl ; ;
+  }
+
 
   void CServersRessource::checkNotifications(void)
@@ -148,6 +189,27 @@
     MPI_Comm_rank(serverComm_, &commRank) ;
     winNotify_->popFromExclusiveWindow(commRank, this, &CServersRessource::notificationsDumpIn) ;
-    if (notifyInType_==NOTIFY_CREATE_POOL) createPool() ;
+    if (notifyInType_==NOTIFY_CREATE_POOL) 
+    {
+      if (CThreadManager::isUsingThreads()) synchronize() ;
+      createPool() ;
+    }
     else if (notifyInType_==NOTIFY_FINALIZE) finalizeSignal() ;
+  }
+
+  void CServersRessource::synchronize(void)
+  {
+    bool out=false ; 
+    size_t timeLine=0 ;
+    std::hash<string> hashString ;
+    int commSize ;
+    MPI_Comm_size(freeRessourcesComm_,&commSize) ;
+    size_t hashId = hashString("CServersRessource::"+to_string(commSize)) ;
+    freeRessourceEventScheduler_->registerEvent(timeLine, hashId) ;
+    while (!out)
+    {
+      CThreadManager::yield() ;
+      out = eventScheduler_->queryEvent(timeLine,hashId) ;
+      if (out) eventScheduler_->popEvent() ;
+    }
   }
 
Index: XIOS3/trunk/src/manager/servers_ressource.hpp
===================================================================
--- XIOS3/trunk/src/manager/servers_ressource.hpp	(revision 2546)
+++ XIOS3/trunk/src/manager/servers_ressource.hpp	(revision 2547)
@@ -55,6 +55,12 @@
     const double eventLoopLatency_=0; 
     double lastEventLoop_=0. ;
-
+    
     private:
+      bool finished_=false;
+    public:
+      bool isFinished(void) { return finished_ ;}
+    private:
+      void synchronize(void) ;
+      void threadEventLoop(void) ;
       shared_ptr<CEventScheduler> eventScheduler_ ;
       shared_ptr<CEventScheduler> freeRessourceEventScheduler_ ;
Index: XIOS3/trunk/src/manager/services.cpp
===================================================================
--- XIOS3/trunk/src/manager/services.cpp	(revision 2546)
+++ XIOS3/trunk/src/manager/services.cpp	(revision 2547)
@@ -5,4 +5,5 @@
 #include "server_context.hpp"
 #include "event_scheduler.hpp"
+#include "thread_manager.hpp"
 #include "timer.hpp"
 
@@ -41,4 +42,6 @@
     oss<<partitionId;
     name_= poolId+"__"+serviceId+"_"+oss.str();
+    
+    if (CThreadManager::isUsingThreads()) CThreadManager::spawnThread(&CService::threadEventLoop, this) ;
   }
 
@@ -124,4 +127,5 @@
 
     eventScheduler_->checkEvent() ;
+   
     for(auto it=contexts_.begin();it!=contexts_.end();++it) 
     {
@@ -134,8 +138,51 @@
       } ;
     }
+  
     CTimer::get("CService::eventLoop").suspend();
     if (contexts_.empty() && finalizeSignal_) return true ;
     else return false ;
   }
+
+  void CService::threadEventLoop(void)
+  {
+    info(100)<<"Launch Thread for  CService::threadEventLoop, service id = "<<name_<<endl ;
+    CThreadManager::threadInitialize() ; 
+    
+    do
+    {
+      CTimer::get("CService::eventLoop").resume();
+      int flag ;
+      MPI_Iprobe(MPI_ANY_SOURCE, MPI_ANY_TAG, MPI_COMM_WORLD, &flag, MPI_STATUS_IGNORE);
+   
+//    double time=MPI_Wtime() ;
+//    if (time-lastEventLoop_ > eventLoopLatency_) 
+//    {
+      checkNotifications() ;
+//      lastEventLoop_=time ;
+//    }
+
+
+      eventScheduler_->checkEvent() ;
+   
+      for(auto it=contexts_.begin();it!=contexts_.end();++it) 
+      {
+        if (it->second->isFinished())
+        {
+          delete it->second ; 
+          contexts_.erase(it) ;
+          // destroy server_context -> to do later
+          break ;
+        } ;
+      }
+
+      CTimer::get("CService::eventLoop").suspend();
+      if (contexts_.empty() && finalizeSignal_) finished_=true ;
+      if (!finished_) CThreadManager::yield() ;
+    } while (!finished_) ;
+    
+    CThreadManager::threadFinalize() ;
+    info(100)<<"Close thread for  CService::threadEventLoop, service id = "<<name_<<endl ;
+  }
+
 
   void CService::sendNotification(int rank)
Index: XIOS3/trunk/src/manager/services.hpp
===================================================================
--- XIOS3/trunk/src/manager/services.hpp	(revision 2546)
+++ XIOS3/trunk/src/manager/services.hpp	(revision 2547)
@@ -24,4 +24,5 @@
 
     bool eventLoop(bool serviceOnly=false) ;
+    void threadEventLoop(void) ;
     void createContext(const std::string& poolId, const std::string& serviceId, const int& partitionId, const std::string& contextId) ;
     void checkCreateContextNotification(void) ;
@@ -41,4 +42,9 @@
     const MPI_Comm& getCommunicator(void) { return serviceComm_ ;}
     
+    private: 
+    bool finished_=false ;
+    public:
+    bool isFinished(void) { return finished_; }
+
     private:
     void sendNotification(int rank) ;
Index: XIOS3/trunk/src/manager/thread_manager.cpp
===================================================================
--- XIOS3/trunk/src/manager/thread_manager.cpp	(revision 2547)
+++ XIOS3/trunk/src/manager/thread_manager.cpp	(revision 2547)
@@ -0,0 +1,9 @@
+#include "thread_manager.hpp"
+
+namespace xios
+{
+  std::mutex* CThreadManager::mtx_;
+  std::map<std::thread::id, CThreadManager::SThreadInfo>* CThreadManager::threads_;
+  std::thread::id CThreadManager::masterThreadId_ = std::this_thread::get_id() ;
+  bool CThreadManager::usingThreads_=false ;
+}
Index: XIOS3/trunk/src/manager/thread_manager.hpp
===================================================================
--- XIOS3/trunk/src/manager/thread_manager.hpp	(revision 2547)
+++ XIOS3/trunk/src/manager/thread_manager.hpp	(revision 2547)
@@ -0,0 +1,157 @@
+#ifndef __THREAD_MANAGER_HPP__
+#define __THREAD_MANAGER_HPP__
+
+#include <thread>             // std::thread
+#include <mutex>              // std::mutex, std::unique_lock
+#include <condition_variable> // std::condition_variable
+#include <map>
+
+
+namespace xios
+{
+  class CThreadManager
+  {
+    private:
+      
+      struct SThreadInfo
+      {
+        std::thread* thread;
+        std::thread::id previous;
+        std::thread::id next;
+        bool isNotified ;
+        std::condition_variable* cvs ;
+        std::unique_lock<std::mutex>* lck;
+        bool finished ;
+        bool isMainThread ;
+      } ;
+
+    
+      static std::mutex* mtx_;
+      static std::map<std::thread::id, SThreadInfo>* threads_;
+      static std::thread::id masterThreadId_ ;
+      static bool usingThreads_ ;
+    
+    public:
+      
+      static int getNumThreads(void) { return threads_->size()-1 ;}
+      
+      template <class Fn, class... Args> 
+      static void spawnThread(Fn&& fn, Args&&... args)
+      {
+        std::thread::id myId=std::this_thread::get_id() ;
+
+        SThreadInfo myThreadInfo ;
+        myThreadInfo.thread=nullptr ;
+        myThreadInfo.previous = myId ;
+        myThreadInfo.next = (*threads_)[myId].next ;
+        myThreadInfo.cvs = new std::condition_variable() ;
+        myThreadInfo.thread = new std::thread(fn, args...) ;
+        myThreadInfo.finished = false ;
+        myThreadInfo.isNotified = false ;
+        (*threads_)[myThreadInfo.thread->get_id()] =  myThreadInfo ;
+        (*threads_)[(*threads_)[myId].next].previous = myThreadInfo.thread->get_id() ;
+        (*threads_)[myId].next = myThreadInfo.thread->get_id() ;  
+
+        do (*threads_)[myId].cvs->wait(*((*threads_)[myId].lck)) ;
+        while(!(*threads_)[myId].isNotified) ;
+
+        (*threads_)[myId].isNotified=false ;
+      }
+
+      static void yield(void)
+      {
+        if (isMasterThread) checkJoin() ;
+        std::thread::id id = std::this_thread::get_id() ;
+        if (getNumThreads()>0)
+        {
+          (*threads_)[(*threads_)[id].next].isNotified=true ;
+          (*threads_)[(*threads_)[id].next].cvs->notify_one() ;
+          do (*threads_)[id].cvs->wait(*((*threads_)[id].lck)) ;
+          while(!(*threads_)[id].isNotified) ;
+
+          (*threads_)[id].isNotified=false ;
+
+        }
+
+      }
+    
+      static void checkJoin(void)
+      {
+        std::thread::id myId = std::this_thread::get_id() ;
+        for(auto it=(*threads_).begin(); it!=(*threads_).end(); )
+        { 
+          if (it->first!=myId)
+          {
+            if (it->second.finished) 
+            {
+              it->second.thread->join() ;
+              it=(*threads_).erase(it) ;
+            }
+            else 
+            {
+              it++ ;
+            }
+          }
+            else it++ ;
+        }
+      }
+
+      static bool isMasterThread(void) { return std::this_thread::get_id()==masterThreadId_; }
+      static bool isUsingThreads(void) { return usingThreads_;}
+      static void threadInitialize(void)
+      {
+        std::unique_lock<std::mutex>* lck = new std::unique_lock<std::mutex>(*mtx_);
+        std::thread::id id=std::this_thread::get_id() ;
+
+        (*threads_)[id].lck = lck ;
+        (*threads_)[(*threads_)[id].previous].isNotified = true ;
+        (*threads_)[(*threads_)[id].previous].cvs->notify_one() ;
+        do (*threads_)[id].cvs->wait(*lck) ; while(!(*threads_)[id].isNotified) ;
+        (*threads_)[id].isNotified=false ;
+      }
+    
+      static void threadFinalize(void)
+      {
+        std::thread::id myId = std::this_thread::get_id() ;
+        (*threads_)[(*threads_)[myId].previous].next = (*threads_)[myId].next;
+        (*threads_)[(*threads_)[myId].next].previous = (*threads_)[myId].previous ;
+        (*threads_)[myId].finished = true ;
+
+        (*threads_)[(*threads_)[myId].next].isNotified=true ;
+        (*threads_)[(*threads_)[myId].next].cvs->notify_one() ;
+      
+        delete (*threads_)[myId].lck ;
+      }
+   
+      static void initialize(bool usingThreads)
+      {
+        mtx_ = new std::mutex ;
+        threads_ = new std::map<std::thread::id, SThreadInfo> ;
+        usingThreads_ = usingThreads ;
+
+        std::thread::id myId= std::this_thread::get_id() ;
+        SThreadInfo myThreadInfo ;
+        myThreadInfo.thread=nullptr ;
+        myThreadInfo.previous = myId ;
+        myThreadInfo.next = myId ; 
+        myThreadInfo.cvs = new std::condition_variable() ;
+        myThreadInfo.lck = new std::unique_lock<std::mutex>(*mtx_) ;
+        myThreadInfo.finished = false ;
+        myThreadInfo.isNotified = false ;
+        (*threads_)[myId] = myThreadInfo ;
+      }
+     
+      static void finalize(void)
+      {
+        
+        std::thread::id myId = std::this_thread::get_id() ;
+        delete (*threads_)[myId].lck ;
+        delete threads_ ;
+        delete mtx_ ;
+      }
+  };
+
+}
+
+
+#endif
Index: XIOS3/trunk/src/manager/token_manager.hpp
===================================================================
--- XIOS3/trunk/src/manager/token_manager.hpp	(revision 2546)
+++ XIOS3/trunk/src/manager/token_manager.hpp	(revision 2547)
@@ -26,27 +26,44 @@
           memset( winBufferRetrieved_, 0, windowSize );
         }
+        MPI_Win_lock_all(0, winCurrentToken_) ;
+        MPI_Win_lock_all(0, winRetrievedToken_) ;
       }
-
+      
+      ~CTokenManager()
+      {
+        MPI_Win_unlock_all(winCurrentToken_) ;
+        MPI_Win_unlock_all(winRetrievedToken_) ;
+        MPI_Win_free(&winCurrentToken_) ;
+        MPI_Win_free(&winRetrievedToken_) ;
+      }
+      
       size_t getToken(void)
       {
         size_t inc=1 ;
         size_t token ;
-        MPI_Win_lock(MPI_LOCK_EXCLUSIVE, leader_, 0, winCurrentToken_) ;
         MPI_Fetch_and_op(&inc, &token, MPI_SIZE_T, leader_, 0, MPI_SUM, winCurrentToken_) ;
-        MPI_Win_unlock(leader_, winCurrentToken_) ;
+        MPI_Win_flush(leader_, winCurrentToken_);
         return token ;
       }
 
-      bool lockToken(size_t token)
+      bool checkToken(size_t token)
       {
         size_t tokenRead ;
-        MPI_Win_lock(MPI_LOCK_SHARED, leader_, 0, winRetrievedToken_) ;
-        MPI_Get(&tokenRead, 1, MPI_SIZE_T, leader_, 0, 1, MPI_SIZE_T, winRetrievedToken_ ) ;
-        MPI_Win_unlock(leader_, winRetrievedToken_) ;
-        if (token==tokenRead) return true ;
-        else return false ;
+        size_t inc=0 ;
+        MPI_Fetch_and_op(&inc, &tokenRead, MPI_SIZE_T, leader_, 0, MPI_NO_OP, winRetrievedToken_) ;
+        MPI_Win_flush(leader_, winRetrievedToken_);
+        return tokenRead==token ;
       }
-
-      void unlockToken(size_t token)
+      
+      void updateToken(size_t token)
+      {
+        size_t inc=1 ;
+        size_t tokenRead ;
+        MPI_Fetch_and_op(&inc, &tokenRead, MPI_SIZE_T, leader_, 0, MPI_SUM, winRetrievedToken_) ;
+        MPI_Win_flush(leader_, winRetrievedToken_);
+        if (token!=tokenRead)  ERROR("void CTokenManager::unlockToken(size_t token)",<<"Cannot release token="<<token<<
+                                     " that is not corresponding to the locked token="<<tokenRead) ;     
+      }
+/*      void unlockToken(size_t token)
       {
         size_t inc=1 ;
@@ -59,5 +76,5 @@
                                      " that is not corresponding to the locked token="<<tokenRead) ;     
       }
-
+*/
     private:
 
Index: XIOS3/trunk/src/manager/window_base.hpp
===================================================================
--- XIOS3/trunk/src/manager/window_base.hpp	(revision 2546)
+++ XIOS3/trunk/src/manager/window_base.hpp	(revision 2547)
@@ -137,5 +137,10 @@
       return MPI_Get(origin_addr, origin_count, origin_datatype, target_rank, target_disp + OFFSET_BUFFER, target_count, target_datatype, window_) ;
     }
-
+    
+    int fetchAndOp(const void *origin_addr, void *result_addr, MPI_Datatype datatype, int target_rank, MPI_Aint target_disp, MPI_Op op)
+    {
+      return MPI_Fetch_and_op(origin_addr, result_addr, datatype, target_rank, target_disp + OFFSET_BUFFER, op, window_ ) ;
+    }
+    
     int compareAndSwap(const void *origin_addr, const void *compare_addr, void *result_addr, MPI_Datatype datatype,
                        int target_rank, MPI_Aint target_disp)
Index: XIOS3/trunk/src/manager/window_dynamic.hpp
===================================================================
--- XIOS3/trunk/src/manager/window_dynamic.hpp	(revision 2547)
+++ XIOS3/trunk/src/manager/window_dynamic.hpp	(revision 2547)
@@ -0,0 +1,225 @@
+#ifndef __WINDOW_DYNAMIC_HPP__
+#define __WINDOW_DYNAMIC_HPP__
+
+#include <map>
+//#include "exception.hpp"
+#include "mpi.hpp"
+#include "cxios.hpp"
+#include <iostream>
+
+namespace xios
+{
+
+
+  class CWindowDynamic
+  {
+    private:
+      void * winBuffer_ ;   
+      const MPI_Aint OFFSET_LOCK=0 ;
+      const int SIZE_LOCK=sizeof(long) ;
+      const MPI_Aint OFFSET_BUFFER =  SIZE_LOCK ;
+      const MPI_Aint OFFSET_BUFFER_SIZE = SIZE_LOCK   ;
+      MPI_Aint bufferSize_ ;
+      const double maxLatency_ = 1e-3 ; // 1ms latency maximum
+      MPI_Win window_ ;
+      MPI_Aint windowSize_ ;
+      int winCommRank_ ;
+      map<int,MPI_Aint> winBufferAddress_ ;
+
+
+    public :
+
+    void allocateBuffer(MPI_Aint size)
+    {
+      bufferSize_ = size ;
+      windowSize_ = size+OFFSET_BUFFER_SIZE ;
+      MPI_Alloc_mem(windowSize_, MPI_INFO_NULL, &winBuffer_) ;
+      MPI_Aint& lock = *((MPI_Aint*)(static_cast<char*>(winBuffer_)+OFFSET_LOCK)) ;
+      lock=0 ;
+    }  
+
+    void create(MPI_Comm winComm)
+    {
+      MPI_Win_create_dynamic(MPI_INFO_NULL, winComm, &window_);
+      CXios::getMpiGarbageCollector().registerWindow(window_) ;
+      MPI_Barrier(winComm) ;
+      MPI_Comm_rank(winComm, &winCommRank_) ;
+      MPI_Win_lock_all(0, window_) ;
+    }
+    
+    void lockAll()
+    {
+      MPI_Win_lock_all(0, window_) ;
+    }
+
+    void unlockAll()
+    {
+      MPI_Win_unlock_all(window_) ;
+    }
+
+    void setWinBufferAddress(MPI_Aint addr, int rank)
+    {
+      winBufferAddress_[rank]=addr ;
+    }
+    
+    MPI_Aint getWinBufferAddress()
+    {
+      MPI_Aint ret ;
+      MPI_Get_address(winBuffer_, &ret) ;
+      return ret ;
+    }
+
+    void* getBufferAddress()
+    {
+      return static_cast<char*>(winBuffer_)+OFFSET_BUFFER_SIZE ;
+    }
+    
+    bool tryLockExclusive(int rank)
+    {
+      long lock = 1;
+      long unlock = 0;
+      long state;
+
+      int flag ;
+      if (rank==winCommRank_) MPI_Win_sync(window_) ;
+      MPI_Compare_and_swap(&lock, &unlock, &state, MPI_LONG, rank, winBufferAddress_[rank]+OFFSET_LOCK, window_) ;
+      MPI_Win_flush(rank, window_);
+//      if (rank==winCommRank_) MPI_Win_sync(window_) ;
+      bool locked = (state == unlock) ;
+      return locked ;
+    }
+
+    bool tryLockShared(int rank, MPI_Op op)
+    {
+      long one = 0x100000000;
+      long res;
+
+      MPI_Fetch_and_op(&one, &res, MPI_LONG, rank, winBufferAddress_[rank]+OFFSET_LOCK, op, window_);
+      MPI_Win_flush(rank, window_);
+      
+      bool locked =  ! (res & 1) ;
+      return locked ;
+    }
+
+    void unlockExclusive(int rank)
+    {
+      int lock = 1;
+      int unlock = 0;
+      int state;
+      
+      if (rank==winCommRank_) MPI_Win_sync(window_) ;
+      MPI_Win_flush(rank, window_);
+      MPI_Compare_and_swap(&unlock, &lock, &state, MPI_INT, rank, winBufferAddress_[rank]+OFFSET_LOCK, window_) ;
+      MPI_Win_flush(rank, window_);
+//      if (rank==winCommRank_) MPI_Win_sync(window_) ;
+      if (lock != state) 
+      {
+        info(100)<<"Bad State : "<<((long*)winBuffer_)[0]<<endl ;
+        ERROR("CWindowBase::unlockWindowExclusive",<<"unlockWindow failed: bad state"<<endl) ; 
+      }
+    }
+
+    void unlockShared(int rank)
+    {
+      int minusone = -1;
+      int res;
+      MPI_Fetch_and_op(&minusone, &res, MPI_INT, rank, winBufferAddress_[rank]+OFFSET_LOCK+4, MPI_SUM, window_);
+      MPI_Win_flush(rank, window_);
+    }
+
+    void lockExclusive(int rank)
+    {
+      double time =  MPI_Wtime() ;
+      bool locked = tryLockExclusive(rank);
+      double lastTime = MPI_Wtime() ;
+      double delta = lastTime-time ;
+      
+      while (!locked)
+      {
+        time = MPI_Wtime() ;
+        if (delta > maxLatency_) delta = maxLatency_ ;
+        if (time >= lastTime+delta)
+        { 
+          locked = tryLockExclusive(rank);
+          delta=delta*2.;
+          lastTime = time ;      
+        }
+      }  
+    }
+
+    void lockShared(int rank)
+    {
+      double time =  MPI_Wtime() ;
+      bool locked = tryLockShared(rank, MPI_SUM);
+      double lastTime = MPI_Wtime() ;
+      double delta = lastTime-time ;
+      
+      while (!locked)
+      {
+        time = MPI_Wtime() ;
+        if (delta > maxLatency_) delta = maxLatency_ ;
+        if (time >= lastTime+delta)
+        { 
+          locked = tryLockShared(rank, MPI_NO_OP);
+          delta=delta*2.;
+          lastTime = time ;      
+        }
+      }  
+    }
+    
+    int attach(MPI_Aint size) 
+    {
+      windowSize_ = size+OFFSET_BUFFER_SIZE ;
+      MPI_Alloc_mem(windowSize_, MPI_INFO_NULL, &winBuffer_) ;
+      MPI_Aint& lock = *((MPI_Aint*)(static_cast<char*>(winBuffer_)+OFFSET_LOCK)) ;
+      lock=0 ;
+      MPI_Win_attach(window_, winBuffer_, size+OFFSET_BUFFER_SIZE) ;
+      setWinBufferAddress(getWinBufferAddress(),winCommRank_) ;
+    }
+    
+    int attach() 
+    {
+      MPI_Win_attach(window_, winBuffer_, windowSize_) ;
+      setWinBufferAddress(getWinBufferAddress(),winCommRank_) ;
+    }
+
+    int detach() 
+    {
+      MPI_Win_detach(window_, winBuffer_) ;
+      MPI_Free_mem(winBuffer_) ;        
+    }
+
+    int flush(int rank)
+    {
+      return MPI_Win_flush(rank, window_) ;
+    }
+
+    int put(const void *origin_addr, int origin_count, MPI_Datatype origin_datatype, int target_rank, MPI_Aint target_disp,
+            int target_count, MPI_Datatype target_datatype)
+    {
+      return MPI_Put(origin_addr, origin_count, origin_datatype, target_rank,  target_disp + OFFSET_BUFFER, target_count, target_datatype, window_) ;
+    }
+
+    int get(void *origin_addr, int origin_count, MPI_Datatype origin_datatype, int target_rank, MPI_Aint target_disp,
+            int target_count, MPI_Datatype target_datatype)
+    {
+      return MPI_Get(origin_addr, origin_count, origin_datatype, target_rank, target_disp + OFFSET_BUFFER, target_count, target_datatype, window_) ;
+    }
+
+    int compareAndSwap(const void *origin_addr, const void *compare_addr, void *result_addr, MPI_Datatype datatype,
+                       int target_rank, MPI_Aint target_disp)
+    {
+      return MPI_Compare_and_swap(origin_addr, compare_addr, result_addr, datatype, target_rank, target_disp + OFFSET_BUFFER, window_) ;
+    }
+
+    ~CWindowDynamic()
+    {
+      MPI_Win_unlock_all(window_) ;
+    }
+
+  } ;
+}
+
+
+
+#endif
